org.apache.sysds.runtime.lineage

## Class Lineage

- java.lang.Object
- - org.apache.sysds.runtime.lineage.Lineage

    public class Lineage
    extends Object

### Constructor Summary

Constructors
Constructor and Description
`Lineage()`
`Lineage(Lineage that)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`void` `clearDedupBlock()`
`void` `clearLineageMap()`
`boolean` `contains(CPOperand variable)`
`void` `createDedupPatch(ProgramBlock pb, ExecutionContext ec)`
`static Lineage` `deserialize(Map<String,String> serialLineage)`
`LineageItem` `get(CPOperand variable)`
`LineageItem` `get(String varName)`
`Map<ProgramBlock,LineageDedupBlock>` `getDedupBlocks()`
`LineageMap` `getLineageMap()`
`LineageItem` `getOrCreate(CPOperand variable)`
`void` `initializeDedupBlock(ProgramBlock pb, ExecutionContext ec)`
`void` `resetDedupPath()`
`static void` `resetInternalState()`
`Map<String,String>` `serialize()`
`void` `set(String varName, LineageItem li)`
`void` `setDedupBlock(LineageDedupBlock ldb)`
`void` `setDedupPathBranch(int pos, boolean value)`
`void` `setInitDedupBlock(LineageDedupBlock ldb)`
`static void` `setLinReuseFull()`
`static void` `setLinReuseFullAndPartial()`
`static void` `setLinReuseNone()`
`static void` `setLinReusePartial()`
`void` `setLiteral(String varName, LineageItem li)`
`void` `trace(Instruction inst, ExecutionContext ec)`
`void` `traceCurrentDedupPath(ProgramBlock pb, ExecutionContext ec)`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Lineage

    public Lineage()

#### Lineage

    public Lineage(Lineage that)

### Method Detail

#### trace

    public void trace(Instruction inst,
                      ExecutionContext ec)

#### traceCurrentDedupPath

    public void traceCurrentDedupPath(ProgramBlock pb,
                                      ExecutionContext ec)

#### getOrCreate

    public LineageItem getOrCreate(CPOperand variable)

#### contains

    public boolean contains(CPOperand variable)

#### get

    public LineageItem get(String varName)

#### setDedupBlock

    public void setDedupBlock(LineageDedupBlock ldb)

#### getLineageMap

    public LineageMap getLineageMap()

#### getDedupBlocks

    public Map<ProgramBlock,LineageDedupBlock> getDedupBlocks()

#### set

    public void set(String varName,
                    LineageItem li)

#### setLiteral

    public void setLiteral(String varName,
                           LineageItem li)

#### get

    public LineageItem get(CPOperand variable)

#### resetDedupPath

    public void resetDedupPath()

#### setDedupPathBranch

    public void setDedupPathBranch(int pos,
                                   boolean value)

#### setInitDedupBlock

    public void setInitDedupBlock(LineageDedupBlock ldb)

#### initializeDedupBlock

    public void initializeDedupBlock(ProgramBlock pb,
                                     ExecutionContext ec)

#### createDedupPatch

    public void createDedupPatch(ProgramBlock pb,
                                 ExecutionContext ec)

#### clearDedupBlock

    public void clearDedupBlock()

#### clearLineageMap

    public void clearLineageMap()

#### serialize

    public Map<String,String> serialize()

#### deserialize

    public static Lineage deserialize(Map<String,String> serialLineage)

#### resetInternalState

    public static void resetInternalState()

#### setLinReusePartial

    public static void setLinReusePartial()

#### setLinReuseFull

    public static void setLinReuseFull()

#### setLinReuseFullAndPartial

    public static void setLinReuseFullAndPartial()

#### setLinReuseNone

    public static void setLinReuseNone()